#################################################
#Newcalendar for SP1 mod by Ironwing and GauGau.#
#Based on Event Calendar by Nermware		#
#Support: boardmod.yabbforums.com			#
#Version 3.3						#
#################################################
$Newcalendarplver = 'NewcalendarSP1 3.3 for SP1';
# CalMain is the main calendar routine, called by YaBB
sub CalMain {
	$rev = "1.3.1";					#This is the Nermware calendar ver num, must not change
	require "$vardir/eventcal.txt";		#This is the settings file
	@sbjlist = split(" ",$sbjlist);
	$yytitle = $calpagetitle;
	$dbfile = "$vardir/eventcaldb";		#This is the database file
	$origcom = qq~$ecaltxt{'58'}eventcalendar.pl v$rev$ecaltxt{'59'}~;# Nermware credit must remain
	$adaptcom = 'Ironwing';
	use Time::Local;
	use CGI;
	$webpage_obj = new CGI;
	$acttype = GetActType();
	@seldate = GetSelDate();
	GetDbData();
	if($acttype =~ /display/) {
		CalBDay2();
		DisCalendar();
		DisCalForm();
	}
	EnterData() if($acttype =~ /enterdata/);
	ViewData() if($acttype =~ /viewdata/);
	if(($acttype =~ /newdata/) || ($acttype =~ /deldata/)) {
		NewData();
		$acttype = display;
		GetDbData();
		if ($addbdays == 1) { 
			CalBDay2();
		}
		DisCalendar();
		DisCalForm();
	}
	SendTrailer();
	&template;
	exit;
}
# GetActType determines type of action selected by user
# called by CalMain sub and IndexCal sub
sub GetActType {
	my($type) = "display";
	$type = $webpage_obj->param('acttype') if(defined($webpage_obj->param('acttype')));
	$type = newdata if(defined($webpage_obj->param('newdata')));
	$type = deldata if(defined($webpage_obj->param('deldata')));
	return('display') if ($type =~ /display/);
	return('enterdata') if ($type =~ /enterdata/);
	return('viewdata') if($type =~/viewdata/);
	return('newdata') if($type =~/newdata/);
	return('deldata') if($type =~/deldata/);
	return('badtype');
}
# GetSelDate determines current time/date or selected time/date to display
# called by CalMain sub and IndexCal sub
sub GetSelDate {
	(my($selmonth),my($selday),my($selyear)) = (gmtime(time-$gmtminos*60))[4,3,5];
	$selyear = $selyear+1900;
	$selmonth = $webpage_obj->param('selmonth') if (defined($webpage_obj->param('selmonth')));
	$selday = $webpage_obj->param('selday') if (defined($webpage_obj->param('selday')));
	$selyear = $webpage_obj->param('selyear') if (defined($webpage_obj->param('selyear')));
	return($selmonth,$selday,$selyear);
}
# GetDbData gets event data from database and builds recurring event data,
# called by CalMain sub and IndexCal sub
sub GetDbData {
	my($thismonth) = $seldate[0];
	my($thisyear) = $seldate[2];
	my($selmonfst) = timegm(0,0,0,1,$thismonth,$thisyear);
	my($nextmonth) = $thismonth+1;
	my($nextyear) = $thisyear;
	if($nextmonth > 11) {
		$nextmonth = 0;
		$nextyear = $thisyear+1;
	}
	my($nxtmonfst) = timegm(0,0,0,1,$nextmonth,$nextyear);
	die("ERROR .. unable to open $dbfile\n") unless fopen(DBFILE,$dbfile);
	while ($strline=<DBFILE>) {
		chop($strline);
		@line = split(/\|/,$strline);
		my($index) = shift(@line);
		$dayinfo{$index} = [ @line ] if($index < $nxtmonfst);
	}
	fclose(DBFILE);
	return if(($acttype !~ /display/) && ($acttype !~ /viewdata/));
	my($daysecs) = 24*60*60;
	my($weeksecs) = 168*60*60;
	my(@dayinfokeys) = keys(%dayinfo);
	foreach $index (@dayinfokeys) {
		my($element) = "";
		my(@entry) = ();
		foreach $element (@{ $dayinfo{$index} }) {
			my(@entry) = split('{',$element);
			my($repeatfor) = $entry[$#entry];
			if($repeatfor > 1) {
				my($newindex) = $index;
				$addsecs = $daysecs if($entry[$#entry-1] =~ /$ecaltxt{'43'}/);
				$addsecs = $weeksecs if($entry[$#entry-1] =~ /$ecaltxt{'44'}/);
				if(($entry[$#entry-1] =~ /$ecaltxt{'43'}/) || ($entry[$#entry-1] =~ /$ecaltxt{'44'}/)) {
					for($i=2;$i<=$repeatfor;$i++) {
						$newindex = $newindex + $addsecs;
						$entry[$#entry] = 0;
						${$dayinfo{$newindex}}[++$#{$dayinfo{$newindex}}] = join('{',@entry) if(($newindex < $nxtmonfst) && ($newindex >= $selmonfst));
					}
					next;
				}
				my($addyears) = my($addmonths) = 0;
				$addyears = 1 if($entry[$#entry-1] =~ /$ecaltxt{'46'}/);
				$addmonths = 1 if($entry[$#entry-1] =~ /$ecaltxt{'45'}/);
				my(@thisdate) = gmtime($index);
				splice(@thisdate,-1,3);
				for($i=2;$i<=$entry[$#entry];$i++) {
					$thisdate[4] = $thisdate[4] + $addmonths;
					$thisdate[5] = $thisdate[5] + $addyears;
					if($thisdate[4] > 11) {
						$thisdate[4]=0;
						$thisdate[5]++;
					}
					$newindex = timegm(@thisdate);
					${$dayinfo{$newindex}}[++$#{$dayinfo{$newindex}}] = $element if(($newindex < $nxtmonfst) && ($newindex >= $selmonfst));
				}
			}
		}
	}
}
#DisCalendar generates month view calendar page, called by CalMain sub
sub DisCalendar {
	require "$sourcedir/MoonPhase.pl";                           #This is the moon phase calculator
	my($thismonth) = $seldate[0];
	my($thisyear) = $seldate[2];
	$monthname = ($ecaltxt{'01'},$ecaltxt{'02'},$ecaltxt{'03'},$ecaltxt{'04'},$ecaltxt{'05'},$ecaltxt{'06'},$ecaltxt{'07'},$ecaltxt{'08'},$ecaltxt{'09'},$ecaltxt{'10'},$ecaltxt{'11'},$ecaltxt{'12'})[$thismonth];
	my($thisdaysecs) = timegm(0,0,0,1,$thismonth,$thisyear);
	my($thisdayweek) = (gmtime($thisdaysecs))[6];
	if ($mondayfirst == 1) {
		if ($thisdayweek == 0) {
			$thisdayweek = 6;
		} else {
			$thisdayweek = $thisdayweek - 1;
		}
	}
	my($daysecs) = 24*60*60;
	my(@today) = gmtime(time-$gmtminos*60);
	my($todaysecs) = timegm(0,0,0,$today[3],$today[4],$today[5]);
	my($nextmonth) = $thismonth+1;
	my($nextyear) = $thisyear;
	if($nextmonth > 11) {
		$nextmonth = 0;
		$nextyear = $thisyear+1;
	}
	my($prevmonth) = $thismonth-1;
	my($prevyear) = $thisyear;
	if($prevmonth < 0) {
		$prevmonth = 11;
		$prevyear = $thisyear-1;
	}
	$yymain .= qq~
<center>
<table border="2" cellpadding="2" cellspacing="3" width="90%">
<caption><span class=\"newcal16\">$caltitle</span></caption>
 <tr>
  <form>
  <th class="newcal1"><span class="newcal12">
      <input type=BUTTON value=$ecaltxt{'20'} onClick='location ="$scripturl?action=newcalendar&selmonth=$prevmonth&selyear=$prevyear"'>
    </span>
  </TH>
  </form>
  <th class="newcal5" colspan=5><span class=\"newcal13\">$monthname &nbsp &nbsp &nbsp &nbsp $thisyear</span></TH>
  <form>
  <th class="newcal1"><span class="newcal12">
      <input type=BUTTON value=$ecaltxt{'21'} onClick='location="$scripturl?action=newcalendar&selmonth=$nextmonth&selyear=$nextyear"'>
    </span>
  </TH>
  </form>
</tr>~;
	if ($mondayfirst == 1) {
		$yymain .= qq~
<tr>
  <th class="newcal6" width="14%" nowrap>&nbsp $ecaltxt{'14'} &nbsp &nbsp</span></TH>
  <th class="newcal6" width="14%" nowrap>&nbsp $ecaltxt{'15'} &nbsp</span></TH>
  <th class="newcal6" width="14%" nowrap>$ecaltxt{'16'}</span></TH>
  <th class="newcal6" width="14%" nowrap>&nbsp $ecaltxt{'17'} &nbsp</span></TH>
  <th class="newcal6" width="14%" nowrap>&nbsp &nbsp $ecaltxt{'18'} &nbsp &nbsp</span></TH>
  <th class="newcal6" width="14%" nowrap>&nbsp $ecaltxt{'19'} &nbsp</span></TH>
  <th class="newcal6" width="14%" nowrap>&nbsp $ecaltxt{'13'} &nbsp &nbsp</span></TH>
</tr>~;
	} else {
		$yymain .= qq~
<tr>
  <th class="newcal6" width="14%" nowrap>&nbsp $ecaltxt{'13'} &nbsp &nbsp</span></TH>
  <th class="newcal6" width="14%" nowrap>&nbsp $ecaltxt{'14'} &nbsp &nbsp</span></TH>
  <th class="newcal6" width="14%" nowrap>&nbsp $ecaltxt{'15'} &nbsp</span></TH>
  <th class="newcal6" width="14%" nowrap>$ecaltxt{'16'}</span></TH>
  <th class="newcal6" width="14%" nowrap>&nbsp $ecaltxt{'17'} &nbsp</span></TH>
  <th class="newcal6" width="14%" nowrap>&nbsp &nbsp $ecaltxt{'18'} &nbsp &nbsp</span></TH>
  <th class="newcal6" width="14%" nowrap>&nbsp $ecaltxt{'19'} &nbsp</span></TH>
</tr>~;
	}
	$yymain .= qq~<tr><td colspan=$thisdayweek></td>~ if($thisdayweek > 0);
	my($thisdaymonth) = 1;
	for($thisdaysecs;$thisdaysecs <= $thisdaysecs+$daysecs*31;$thisdaysecs=$thisdaysecs+$daysecs) {
		$thismoonsecs = $thisdaysecs+(12*60*60);
		last if ((gmtime($thisdaysecs))[4] != $thismonth);
		$data="";
		($thisdaymonth,$thisdayweek) = (gmtime($thisdaysecs))[3,6];
		if ($mondayfirst == 1) {
			if ($thisdayweek == 0) {
				$thisdayweek = 6;
			} else {
				$thisdayweek = $thisdayweek - 1;
			}
		}
		if (defined($dayinfo{$thisdaysecs})) {
			$data = "<span class=newcal17>";
			foreach $info (@{ $dayinfo{$thisdaysecs} }) {
				@daydata = split(/\{/,$info);
				next if($daydata[1] =~ /DELETED/);
# Run UBBC interpreter on the event name.
				$message = $daydata[0]; # put the message back into the proper variable to do ubbc on it
				&wrap;
				if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
				&wrap2;
				$daydata[0] = $message;
# End UBBC
				$data = $data . " <li><span class=newcal17><A HREF=\"$scripturl?action=newcalendar&selmonth=$thismonth&selday=$thisdaymonth&selyear=$thisyear&acttype=viewdata\">$daydata[0]</A></span></li>";
			}
			$data = $data . "</span><br>";
# Censor the subject.
			&LoadCensorList;
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$data =~ s~\Q$tmpa\E~$tmpb~gi;
			}
# End censor subject routine
		}
# Add bday code
		if ($addbdays == 1) {
			while (($bdaykey, $bdayindex) = each %bdayshash) {
				if ($bdayindex == $thisdaysecs) {
					$data .= qq~<li><span class=newcal17>$ecaltxt{'57'}$bdaykey</li></span><br>~;
				}
			}
		}
# End bday code
# Add moon phase info
		if ($newcalmoon == 1) {
			( $MoonPhase, $MoonIllum, $MoonAge, $MoonDist, $MoonAng, $SunDist, $SunAng ) = phase($thismoonsecs);
			if ( ($MoonPhase >= 0.48305) && ( $MoonPhase <= 0.51695) ){
				$data = $data . '<br>' . qq~<span class=newcal17><img src="$imagesdir/moonfull.gif" alt="" border="0"> $ecaltxt{'78'}</span>~;
			}
			if ( ($MoonPhase <= 0.01695) || ( $MoonPhase >= 0.98305) ){
				$data = $data . '<br>' . qq~<span class=newcal17><img src="$imagesdir/moonnew.gif" alt="" border="0"> $ecaltxt{'77'}</span>~;
			}
		}
# end moon phase info
		if($thisdayweek == 0) {
			$yymain .= qq~</tr><tr><td class="newcal7" valign=top align=left>~;
		}
		else {
			$yymain .= qq~  <td class="newcal7" valign=top align=left>~;
		}
		if($username ne "Guest" || $newcalguest == 1){
			if($todaysecs == $thisdaysecs) {
				$yymain .= qq~
<A HREF="$scripturl?action=newcalendar&selmonth=$thismonth&selday=$thisdaymonth&selyear=$thisyear&acttype=enterdata">
<span class=\"newcal14\">$thisdaymonth</span></A>
$data</td>
~;
			}
			else {
				$yymain .= qq~
<A HREF="$scripturl?action=newcalendar&selmonth=$thismonth&selday=$thisdaymonth&selyear=$thisyear&acttype=enterdata">
<span class=\"newcal15\">$thisdaymonth</span></A>
$data</td>
~;
			}
		}
		else {
			if($todaysecs == $thisdaysecs) {
				$yymain .= qq~
<span class=\"newcal14\">$thisdaymonth</span>
$data</td>
~;
			}
			else {
				$yymain .= qq~
<span class=\"newcal15\">$thisdaymonth</span>
$data</td>
~;
			}
		}
	}
	$yymain .= qq~</tr></table><br>~;
	$yymain .= qq~
<span class=\"newcal17\">
$ecaltxt{'24'}
<BR>
$ecaltxt{'25'}
</span>
~;
}
# DisCalForm displays select month-year form at bottom of month view page, called by CalMain
sub DisCalForm {
	$yymain .= qq~
<form method="post" action="$scripturl?action=newcalendar" enctype="application/x-www-form-urlencoded" name="calform">
<table border="2" cellpadding="2" cellspacing="3" width="90%">
<tr>
  <th class="newcal5">$ecaltxt{'26'}</TH>
  <th class="newcal5">$ecaltxt{'27'}</TH>
  <th class="newcal5">$ecaltxt{'28'}</TH>
</tr>
<tr><td class="newcal2" align=center Valign=MIDDLE>
<select name="selmonth" size="1">
<option SELECTED value="0">$ecaltxt{'01'}
<option  value="1">$ecaltxt{'02'}
<option  value="2">$ecaltxt{'03'}
<option  value="3">$ecaltxt{'04'}
<option  value="4">$ecaltxt{'05'}
<option  value="5">$ecaltxt{'06'}
<option  value="6">$ecaltxt{'07'}
<option  value="7">$ecaltxt{'08'}
<option  value="8">$ecaltxt{'09'}
<option  value="9">$ecaltxt{'10'}
<option  value="10">$ecaltxt{'11'}
<option  value="11">$ecaltxt{'12'}
</select>
</td><td class="newcal2" align=center Valign=MIDDLE>
<select name="selyear" size="1">
<option  value="2001">2001
<option SELECTED value="2002">2002
<option  value="2003">2003
<option  value="2004">2004
<option  value="2005">2005
<option  value="2006">2006
<option  value="2007">2007
<option  value="2008">2008
<option  value="2009">2009
<option  value="2010">2010
</select>
</td><td class="newcal2" align=center Valign=MIDDLE>
<input type="submit" name="$ecaltxt{'29'}" value="$ecaltxt{'29'}"></tr></table>
</form>
~;
}
# EnterData generates Edit Events page, called by CalMain
sub EnterData {
	my($daynum) = timegm(0,0,0,$seldate[1],$seldate[0],$seldate[2]);
	if (defined($dayinfo{$daynum})) {
		my($entrynum) = 0;
			foreach $entry (@{ $dayinfo{$daynum} }) {
				my(@daydata) = split(/\{/,$entry);
				$dayvars[$entrynum] = [ @daydata ];
				$entrynum++;
			}
		}
	if ($newcaldate == 1) {
		$newcaldatestring = "$seldate[1]".'/'."${seldate[0]+1}".'/'."$seldate[2]";
	} else {
		$newcaldatestring = "${seldate[0]+1}/$seldate[1]/$seldate[2]";
	}
	my($entrynumstr)=1;
	my($title) = "";
	my($subject) = "$sbjdefault";
	my($repeatnum) = 1;
	my($repeatby) = "Daily";
	my($comment) = "";
	my($eventusername) = 'Invalid user name placeholder'; #Sets variable to string no legitimate user name could possibly be.
	$yymain .= qq~
<CENTER>
<h2>$entitle</span></h2>
<form method="POST"  enctype="application/x-www-form-urlencoded">
<input type="button" name="Back" value="$ecaltxt{'22'}" onclick="self.history.back()">
</form>
<hr width="80%">
</CENTER>
~;
	$newcalmax2 = $newcalmax - 1;
	for ($entrynum=0;$entrynum<=$newcalmax2;$entrynum++) {
		if (${$dayvars[$entrynum]}[1] !~ /DELETED/) {
			$title = ${$dayvars[$entrynum]}[0] if (defined(${$dayvars[$entrynum]}[0]));
			$subject = ${$dayvars[$entrynum]}[1] if (defined(${$dayvars[$entrynum]}[1]));
			$comment = ${$dayvars[$entrynum]}[2] if (defined(${$dayvars[$entrynum]}[2]));
			$comment =~ s~<br>~\n~g;
			$eventusername = ${$dayvars[$entrynum]}[3] if (defined(${$dayvars[$entrynum]}[3]));
			$repeatby = ${$dayvars[$entrynum]}[4] if (defined(${$dayvars[$entrynum]}[4]));
			$repeatnum = ${$dayvars[$entrynum]}[5] if (defined(${$dayvars[$entrynum]}[5]));
		}
		if($username eq $eventusername || $settings[7] eq 'Administrator' || $eventusername eq 'Invalid user name placeholder') {
			if($eventusername eq 'Invalid user name placeholder') {$eventusername = $username};  #Sets new events to current username
			$yymain .= qq~
<form method="post" action="$scripturl?action=newcalendar" enctype="application/x-www-form-urlencoded">
<input name=\"formnum\" type=HIDDEN value=\"$entrynum\">
<input name=\"selmonth\" type=HIDDEN value=\"$seldate[0]\">
<input name=\"selday\" type=HIDDEN value=\"$seldate[1]\">
<input name=\"selyear\" type=HIDDEN value=\"$seldate[2]\">
<input name=\"eventusername\" type=HIDDEN value=\"$eventusername\">
<table border=2 width=90%>
  <caption><span class="newcal18">
    $ecaltxt{'41'}$entrynumstr$ecaltxt{'42'}$newcaldatestring
  </span></CAPTION>
  <tr>
<th class="newcal1">$ecaltxt{'31'}</span></TH>
  <td class="newcal1" align=center>
    <input name="title" type=text size=14 maxlength=18 value="$title"></td>
  <th class="newcal8">$ecaltxt{'37'}</span></TH>
  <td class="newcal8" align=center><input name="repeatnum" type=text size=2  maxlength=2 value="$repeatnum"></td>
  <td class="newcal8" align=center><select name="repeatby" size=1 value="$repeatby">
~;
			foreach $item ($ecaltxt{'43'},$ecaltxt{'44'},$ecaltxt{'45'},$ecaltxt{'46'}) {
				if($repeatby =~ /$item/) {
					$yymain .= qq~	  <option selected>$item(s)<br>~;
				}
				else {
					$yymain .= qq~	  <option>$item(s)<br>~;
				}
			}
			$yymain .= qq~
  </select></td>
  </tr><tr>
  <th class="newcal2">$ecaltxt{'50'}</span></TH>
  <td class="newcal2" align=center><select name="subject" size=4 value="$subject">
 ~;
			foreach $item (@sbjlist) {
				if($subject =~ /$item/) {
					$yymain .= qq~	  <option selected>$item<br>~;
				}
				else {
					$yymain .= qq~	  <option>$item<br>~;
				}
			}
			$yymain .= qq~
  </select></td>
  <th class="newcal3">$ecaltxt{'35'}</span></TH>
  <td class="newcal3" colspan=2 align=center>
    <textarea name="comment" rows=4 cols=70 wrap="physical">$comment</textarea></td>
  </tr>
  <tr><th class="newcal9" colspan=2>
    <input name="deldata" type=submit value="$ecaltxt{'47'}$entrynumstr"></TH>
  <th class="newcal10">$ecaltxt{'54'}</span></TH>
  <th class="newcal10" colspan=1>
  $eventusername</TH>
  <th class="newcal11" colspan=1>
    <input name="newdata" type=submit value="$ecaltxt{'48'}$entrynumstr"></TH>
  </tr>
  </table></form>
~;
		}
# The above closing bracket is the end of the username controlled exclusion
		$entrynumstr++;
		$title = "";
		$subject = "$sbjdefault";
		$repeatnum = 1;
		$repeatby = "Daily";
		$comment = "";
		$eventusername = 'Invalid user name placeholder'; #reset the variable for the next iteration
	}
	$yymain .=qq~
<span class=\"newcal20\">$ecaltxt{'53'}
</span>
<span class=\"newcal19\">
<BR>
<table border="0">
<tr>
<td valign=top>$ecaltxt{'31'}</td>
<td valign=top>$ecaltxt{'32'}</td>
</tr>
<tr>
<td valign=top>$ecaltxt{'33'}</td>
<td valign=top>$ecaltxt{'34'}</td>
</tr>
<tr>
<td valign=top>$ecaltxt{'35'}</td>
<td valign=top>$ecaltxt{'36'}</td>
</tr>
<tr>
<td valign=top>$ecaltxt{'37'}</td>
<td valign=top>$ecaltxt{'38'}</td>
</tr>
<tr>
<td valign=top>$ecaltxt{'39'}</td>
<td valign=top>$ecaltxt{'40'}</td>
</tr>
</table>
</span>
<CENTER>
<hr width="80%">
</CENTER>
~;
}
# ViewData shows Events Details page, called by CalMain
sub ViewData {
	my($daynum) = timegm(0,0,0,$seldate[1],$seldate[0],$seldate[2]);
	if (defined($dayinfo{$daynum})) {
		my($entrynum) = 0;
		foreach $entry (@{ $dayinfo{$daynum} }) {
			my(@daydata) = split(/\{/,$entry);
			$dayvars[$entrynum] = [ @daydata ];
			$entrynum++;
		}
	}
	if ($newcaldate == 1) {
		$newcaldatestring = "$seldate[1]".'/'."${seldate[0]+1}".'/'."$seldate[2]";
	} else {
		$newcaldatestring = "${seldate[0]+1}/$seldate[1]/$seldate[2]";
	}
	my($subject) = "";
	my($commentview) = "";
	$yymain .= qq~
<CENTER>
<h2>$vwtitle</span></h2>
<form method="POST"  enctype="application/x-www-form-urlencoded">
<input type="button" name="Back" value="$ecaltxt{'22'}" onclick="self.history.back()">
</form>
~;
	$yymain .= qq~
<hr width="80%">
<table border=0 width=80%>
  <caption>
    $ecaltxt{'49'}$newcaldatestring</span></CAPTION>
  </tr><tr><td class="newcal4" colspan=2><hr width=97% size=4></td></tr>
~;
	$newcalmax2 = $newcalmax - 1;
	for ($entrynum=0;$entrynum<=$newcalmax2;$entrynum++) {
		next if !(defined(${$dayvars[$entrynum]}[0]));
		next if(${$dayvars[$entrynum]}[1] =~ /DELETED/);
# Addon for user security
		$commentview = ${$dayvars[$entrynum]}[2] if (defined(${$dayvars[$entrynum]}[2]));
		$eventusername = ${$dayvars[$entrynum]}[3] if (defined(${$dayvars[$entrynum]}[3]));
# Censor the subject and message.
		&LoadCensorList;
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$commentview =~ s~\Q$tmpa\E~$tmpb~gi;
			${$dayvars[$entrynum]}[0] =~ s~\Q$tmpa\E~$tmpb~gi;
		}

# Run UBBC interpreter on the description.
		$commentviewsend = $commentview;    #bypass UBBC for SendEvent
		$message = $commentview; # put the message back into the proper variable to do ubbc on it
		&wrap;
		if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
		&wrap2;
		$commentview = $message;
# Run UBBC interpreter on the event name.
		$eventnamesend = ${dayvars[$entrynum]}[0];    #bypass UBBC for SendEvent
		$message = ${dayvars[$entrynum]}[0]; # put the message back into the proper variable to do ubbc on it
		&wrap;
		if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
		&wrap2;
		${dayvars[$entrynum]}[0] = $message;
# End UBBC
#End addon for user security
		$yymain .= qq~
  <tr>
    <th class="newcal1" width="20%">$ecaltxt{'31'}</span></TH>
    <td class="newcal1" align=left>  ${$dayvars[$entrynum]}[0]</span></td>
  </tr><tr>
    <th class="newcal2" width="20%">$ecaltxt{'50'}</span></TH>
    <td class="newcal2" align=left>${$dayvars[$entrynum]}[1]</span></td>
  </tr><tr>
    <th class="newcal3" width="20%">$ecaltxt{'35'}</span></TH>
    <td class="newcal3" align=left>$commentview</td>
  </tr><tr>
    <th class="newcal1" width="20%">$ecaltxt{'54'}</span></TH>
    <td class="newcal1" align=left> $eventusername</td>
  </tr>
  <tr>
    <td class="newcal4" colspan=2><hr width=97% size=4></td>
  </tr>
		~;
	}
	$yymain .= qq~</table><br>~;
}
# NewData writes new enteries to database file, called by CalMain sub
sub NewData {
	my($daynum) = timegm(0,0,0,$seldate[1],$seldate[0],$seldate[2]);
	my($arrayloc) = $webpage_obj->param('formnum');
	my($title) = $webpage_obj->param('title');
	my($subject) = $webpage_obj->param('subject');
	my($comment) = $webpage_obj->param('comment');
	my($eventusername) = $webpage_obj->param('eventusername');
	my($repeatby) = $webpage_obj->param('repeatby');
	my($repeatnum) = $webpage_obj->param('repeatnum');
# Addon for user security
	$title =~ s/\cM//g;
	$title =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
	$title =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
	$title =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
	$eventusername =~ tr/!-~/ /cs;
	if (length($comment)>$MaxMessLen) { &fatal_error($txt{'499'}); }
	&spam_protection;
	$comment =~ s/\cM//g;
	$comment =~ s~\[([^\]]{0,30})\n([^\]]{0,30})\]~\[$1$2\]~g;
	$comment =~ s~\[/([^\]]{0,30})\n([^\]]{0,30})\]~\[/$1$2\]~g;
	$comment =~ s~(\w+://[^<>\s\n\"\]\[]+)\n([^<>\s\n\"\]\[]+)~$1\n$2~g;
	&ToHTML($comment);
	$comment =~ s~\t~ \&nbsp; \&nbsp; \&nbsp;~g;
	$comment =~ s~\n~<br>~g;
# End addon for user security
#	$repeatby =~ tr/!-~/ /cs;
	$repeatnum =~ tr/!-~/ /cs;
	$title =~ s/[\{\|]//g;
	$subject =~ s/[\{\|]//g;
	$comment =~ s/[\{\|]//g;
	$eventusername =~ s/[\{\|]//g;
	$repeatby =~ s/[\{\|]//g;
	$repeatnum =~ s/[\{\|]//g;
	$subject = "DELETED" if($acttype=~/deldata/);
	my($dbentry) = join( '{',$title,$subject,$comment,$eventusername,$repeatby,$repeatnum);
	${$dayinfo{$daynum}}[$arrayloc]="$dbentry";
	my($dbrow) = "$daynum";
	foreach $one (@{$dayinfo{$daynum}}) {
		$dbrow = join('|',$dbrow,$one);
	}
	die("ERROR .. unable to open $dbfile\n") unless fopen(DBFILE,">>$dbfile");
	print(DBFILE "$dbrow\n");
	fclose(DBFILE);
	CompactCal();
}
# SendTrailer puts footer at bottom of all calendar pages.
# Nermware credit must be shown on all calendar pages.
sub SendTrailer {
	$yymain .= qq~
<br><center><H3><a href=\"$scripturl\">$ecaltxt{'23'}$mbname</a></H3>
<br><a href="http://www.nermware.com">$origcom</a>
<BR>$Newcalendarplver$ecaltxt{'51'}<a href="mailto:admin\@mineralarts.com?SUBJECT=The Newcalendar mod $Newcalendarplver">$adaptcom</a></span></center>
~;
}
# IndexCal and IndexCal2 show today's events in Info Center on BoardIndex
# Split into two subs to allow for addon mods (like CalBDay), called by YaBB
sub IndexCal {
	require "$vardir/eventcal.txt";				       #This is the settings file
	@sbjlist = split(" ",$sbjlist);
	$yytitle = $calpagetitle;
	$dbfile = "$vardir/eventcaldb";				       #This is the database file
	use Time::Local;	#keep?  Try without and see
	use CGI;		#Already called in YaBB but may need more functions
	$webpage_obj = new CGI; #keep or lose?
	$acttype = GetActType();
	@seldate = GetSelDate();
	GetDbData();
	if ($addbdays == 1) {
		CalBDay();
	}
	IndexCal2();
}
# IndexCal2 shows today's events in Info Center on BoardIndex, called by IndexCal sub
sub IndexCal2 {
	my($thismonth) = $seldate[0];
	my($thisyear) = $seldate[2];
	$monthname = ($ecaltxt{'01'},$ecaltxt{'02'},$ecaltxt{'03'},$ecaltxt{'04'},$ecaltxt{'05'},$ecaltxt{'06'},$ecaltxt{'07'},$ecaltxt{'08'},$ecaltxt{'09'},$ecaltxt{'10'},$ecaltxt{'11'},$ecaltxt{'12'})[$thismonth];
	my($thisdaysecs) = timegm(0,0,0,1,$thismonth,$thisyear);
	my($thisdayweek) = (gmtime($thisdaysecs))[6];
	my($daysecs) = 24*60*60;
	my(@today) = gmtime(time-$gmtminos*60);
	my($todaysecs) = timegm(0,0,0,$today[3],$today[4],$today[5]);
	my($nextmonth) = $thismonth+1;
	my($nextyear) = $thisyear;
	if($nextmonth > 11) {
		$nextmonth = 0;
		$nextyear = $thisyear+1;
	}
	my($prevmonth) = $thismonth-1;
	my($prevyear) = $thisyear;
	if($prevmonth < 0) {
		$prevmonth = 11;
		$prevyear = $thisyear-1;
	}
	my($thisdaymonth) = 1;
	for($thisdaysecs;$thisdaysecs <= $thisdaysecs+$daysecs*31;$thisdaysecs=$thisdaysecs+$daysecs) {
		last if ((gmtime($thisdaysecs))[4] != $thismonth);
		$data="";
		($thisdaymonth,$thisdayweek) = (gmtime($thisdaysecs))[3,6];
		if (defined($dayinfo{$thisdaysecs})) {
			$data = "";
			foreach $item (@sbjlist) {
				$itemcount=0;
				foreach $info (@{ $dayinfo{$thisdaysecs} }) {
					@daydata = split(/\{/,$info);
					next if($daydata[1] =~ /DELETED/);
# Run UBBC interpreter on the event name.
					$message = $daydata[0]; # put the message back into the proper variable to do ubbc on it
					&wrap;
					if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
					&wrap2;
					$daydata[0] = $message;
# End UBBC
                              $daydata[0] =~ s/(^.+)( $)/$1/; 
					if($daydata[1] =~ /$item/) {
						if ($itemcount == 0) {
							$data = $data . qq~<li>$daydata[1]:\&nbsp\;<A HREF=\"$scripturl?action=newcalendar&selmonth=$thismonth&selday=$thisdaymonth&selyear=$thisyear&acttype=viewdata\">$daydata[0]</A>~;
							$itemcount++;
						} else {
							$data = $data . qq~,\&nbsp\;<A HREF=\"$scripturl?action=newcalendar&selmonth=$thismonth&selday=$thisdaymonth&selyear=$thisyear&acttype=viewdata\">$daydata[0]</A>~;
							$itemcount++;
						}
					}
				}
			}
# Censor the subject.
			&LoadCensorList;
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$data =~ s~\Q$tmpa\E~$tmpb~gi;
			}
# End censor subject routine
		}
# Add birthday info from CalBDay
		if ($addbdays == 1) {
			$data = $data . "$calwhobg";
		}
		if($todaysecs == $thisdaysecs) {
			$yymain .= qq~$data~;
		}
	}
}
# CalBDay adds Today's Birthdays to Info Center and SSI script, called by IndexCal and IncludeCal subs
sub CalBDay {
	&timeformat($date);
	($tocheckm, $tocheckd, $years) = split(/\//, $date);
	($year, $trash) = split(/ /, $years);
	$calwhobd = "";
	$countbd = 0;
	fopen(FILE, "$memberdir/memberlist.txt") || die "cannot open list file";
	@members = <FILE>;
	fclose(FILE);
	foreach $usernames (@members) {
		chomp $usernames;
	      if ( -e "$memberdir/$usernames.dat") {
			fopen(FILE, "$memberdir/$usernames.dat") || die "cannot open user file";
			@userbd = <FILE>;
			fclose(FILE);
			chomp $userbd[16];
			($matchm, $matchd, $useryear) = split(/\//, $userbd[16]);
			if(($tocheckm == $matchm) && ($tocheckd == $matchd)) {
			$age = $year - $useryear + 2000;
				$calwhobg .=qq~<a href=$cgi&action=viewprofile&username=$usernames>$userbd[1]</a> ($age) ~;
				$countbd++;
			}
		}
	}#end foreach
	chomp $calwhobg;
	if ($calwhobg ne "") {$calwhobg = qq~<li>$ecaltxt{'56'}$calwhobg</li>~;}
}
# CalBDay2 adds All Birthdays to Calendar, called by CalMain sub
sub CalBDay2 {
	%bdayshash;  #keys are userprofstrings, values are birthdays in timegm format
	my $thisyear = $seldate[2];
	$userprofstring = "";
	open(FILE, "$memberdir/memberlist.txt") || die "cannot open list file";
	@members = <FILE>;
	close(FILE);
	foreach $usernames (@members) {
		chomp $usernames;
	      if ( -e "$memberdir/$usernames.dat") {
			fopen(FILE, "$memberdir/$usernames.dat") || die "cannot open user file";
			@userbd = <FILE>;
			fclose(FILE);
			chomp $userbd[16];
#skip user if no birthday in file or birthday date invalid.
			if ($userbd[16] ne "") {
				($usermonth, $userday, $dummyyear) = split(/\//, $userbd[16]);
				if ($usermonth > 0 && $usermonth < 13) {
					if ($userday > 0 && $userday < 32) {
						$usermonth = $usermonth - 1;
						$bdayindex = timegm(0,0,0,$userday,$usermonth,$thisyear);
						$userprofstring = qq~<a href=$cgi&action=viewprofile&username=$usernames>$userbd[1]</a>~;
						$bdayshash{$userprofstring} = $bdayindex;
					}
				}
			}
		}# end file exists
	}#end foreach
}
# IncludeCal and IncludeCal2 show today's events on any HTML page through include virtual
# Split into two subs to allow for addon mods (like CalBDay), called by YaBB
sub IncludeCal {
	require "$vardir/eventcal.txt";				       #This is the settings file
	require "$sourcedir/MoonPhase.pl";                           #This is the moon phase calculator
	@sbjlist = split(" ",$sbjlist);
	$yytitle = $calpagetitle;
	$dbfile = "$vardir/eventcaldb";				       #This is the database file
	use Time::Local;	#keep?  Try without and see
	use CGI;		#Already called in YaBB but may need more functions
	$webpage_obj = new CGI; #keep or lose?
	$acttype = GetActType();
	@seldate = GetSelDate();
	GetDbData();
	if ($addbdays == 1) {
		CalBDay();
	}
	IncludeCal2();
	exit;
}
# IncludeCal2 shows today's events as SSI call on html pages, called by IncludeCal sub
sub IncludeCal2 {
	my($thismonth) = $seldate[0];
	my($thisyear) = $seldate[2];
	$monthname = ($ecaltxt{'01'},$ecaltxt{'02'},$ecaltxt{'03'},$ecaltxt{'04'},$ecaltxt{'05'},$ecaltxt{'06'},$ecaltxt{'07'},$ecaltxt{'08'},$ecaltxt{'09'},$ecaltxt{'10'},$ecaltxt{'11'},$ecaltxt{'12'})[$thismonth];
	my($thisdaysecs) = timegm(0,0,0,1,$thismonth,$thisyear);
	my($thisdayweek) = (gmtime($thisdaysecs))[6];
	my($daysecs) = 24*60*60;
	my(@today) = gmtime(time-$gmtminos*60);
	my($todaysecs) = timegm(0,0,0,$today[3],$today[4],$today[5]);
	my($nextmonth) = $thismonth+1;
	my($nextyear) = $thisyear;
	if($nextmonth > 11) {
		$nextmonth = 0;
		$nextyear = $thisyear+1;
	}
	my($prevmonth) = $thismonth-1;
	my($prevyear) = $thisyear;
	if($prevmonth < 0) {
		$prevmonth = 11;
		$prevyear = $thisyear-1;
	}
	my($thisdaymonth) = 1;
	for($thisdaysecs;$thisdaysecs <= $thisdaysecs+$daysecs*31;$thisdaysecs=$thisdaysecs+$daysecs) {
		last if ((gmtime($thisdaysecs))[4] != $thismonth);
		$data="";
		($thisdaymonth,$thisdayweek) = (gmtime($thisdaysecs))[3,6];
		if (defined($dayinfo{$thisdaysecs})) {
			$data = "";
			foreach $item (@sbjlist) {
				$itemcount=0;
				foreach $info (@{ $dayinfo{$thisdaysecs} }) {
					@daydata = split(/\{/,$info);
					next if($daydata[1] =~ /DELETED/);
# Run UBBC interpreter on the event name.
					$message = $daydata[0]; # put the message back into the proper variable to do ubbc on it
					&wrap;
					if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
					&wrap2;
					$daydata[0] = $message;
# End UBBC
					$daydata[0] =~ s/(^.+)( $)/$1/;
					if($daydata[1] =~ /$item/) {
						if ($itemcount == 0) {
							$data = $data . qq~<li>$daydata[1]:\&nbsp\;<A HREF=\"$scripturl?action=newcalendar&selmonth=$thismonth&selday=$thisdaymonth&selyear=$thisyear&acttype=viewdata\">$daydata[0]</A>~;
							$itemcount++;
						} else {
							$data = $data . qq~,\&nbsp\;<A HREF=\"$scripturl?action=newcalendar&selmonth=$thismonth&selday=$thisdaymonth&selyear=$thisyear&acttype=viewdata\">$daydata[0]</A>~;
							$itemcount++;
						}
 					}
				}
			}
# Censor the subject.
			&LoadCensorList;
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$data =~ s~\Q$tmpa\E~$tmpb~gi;
			}
# End censor subject routine
		}
# Add birthday info from CalBDay
		if ($addbdays == 1) {
			$data = $data . "$calwhobg";
		}
# Add moon phase info
		if ($newcalmoon2 == 1) {
			( $MoonPhase, $MoonIllum, $MoonAge, $MoonDist, $MoonAng, $SunDist, $SunAng ) = phase();
			my ($newphaselow) = 0.016666667;
			my ($newphasehigh) = 0.983333333;
			my ($phaseincrement) = 0.033333333;

			if ( ($MoonPhase < $newphaselow) || ($MoonPhase > $newphasehigh) ){
				$data = $data . '<br>' . qq~<img src="$imagesdir/moon00.gif" alt="" border="0">~;
			} else {
				$gifnumber = 1;
				for ($phasescan = $newphaselow; $phasescan < $newphasehigh; $phasescan += $phaseincrement) {
					if ( ($MoonPhase > $phasescan) && ( $MoonPhase <= ($phasescan + $phaseincrement)) ){
						if ($gifnumber < 10) {
							$data = $data . '<br>' . qq~<img src="$imagesdir/moon0$gifnumber.gif" alt="" border="0">~;
						} else {
							$data = $data . '<br>' . qq~<img src="$imagesdir/moon$gifnumber.gif" alt="" border="0">~;
						}
					}
					$gifnumber++;
				}
			}
		}
# end moon phase info
		if($todaysecs == $thisdaysecs) {
			print qq~Content-type: text/html\n\n~;
			if ($data ne "") {
				print qq~$data~;
			}
			else {
				print qq~$ecaltxt{'73'}~;
			}
		}
	}
}
#CompactCal removes duplicate calendar entries.  Called by sub NewData.
sub CompactCal {
# Only last record for a date is kept in hash since index is reused.
# Since this sub is run each time NewData is called, the database should never contain duplicate date info.
# In campactdayinfo hash: keys are index dates and values are complete date-event strings
my %compactdayinfo;
	die("ERROR .. unable to open $dbfile\n") unless fopen(DBFILE,$dbfile);
	$dummy=<DBFILE>; # read first line which is always empty
	while ($strline=<DBFILE>) {
		chop($strline);
		@line = split(/\|/,$strline);
		my($index) = shift(@line);
		$compactdayinfo{$index} = $strline;
	}
	fclose(DBFILE);
# now write events back to dbfile without duplicates.
	fopen(DBFILE, ">$dbfile");
	print DBFILE qq~\n~;
	while (($dateindex, $dayevents) = each %compactdayinfo) {
		print DBFILE qq~$dayevents\n~;
	}
	fclose(DBFILE);
}
# CalSettings generates edit settings page for Newcalendar in the Admin Center.  Calls CalSettings2.
sub CalSettings {
	&is_admin;
	require "$vardir/eventcal.txt";
	my($newcalopenchecked);
	my($newcaldatechecked);
	my($newcalmoonchecked);
	my($newcalmoon2checked);
	my($newcalguestchecked);
	my($mondayfirstchecked);
	my($addbdayschecked);	
	if ($newcalopen) { $newcalopenchecked = ' checked'; }
	if ($newcaldate) { $newcaldatechecked = ' checked'; }
	if ($newcalmoon) { $newcalmoonchecked = ' checked'; }
	if ($newcalmoon2) { $newcalmoon2checked = ' checked'; }
	if ($newcalguest) { $newcalguestchecked = ' checked'; }
	if ($mondayfirst) { $mondayfirstchecked = ' checked'; }
	if ($addbdays) { $addbdayschecked = ' checked'; }
	$yymain .= qq~
<form action="$cgi;action=newcalset2" method="POST">
<table width="90%" border="0" cellspacing="1" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
  <td>
  <table border="0" cellspacing="0" cellpadding="4" align="center">
  <tr>
    <td class="titlebg" bgcolor="$color{'titlebg'}" colspan=2>
    <img src="$imagesdir/preferences.gif" alt="" border="0">
    <font size=2 class="text1" color="$color{'titletext'}"><b>$ecaltxt{'60'}</b></font></td>
  </tr><tr>
    <td class="windowbg" bgcolor="$color{'windowbg'}" colspan=2><BR><font size="1">$ecaltxt{'61'}</font><BR><BR></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$ecaltxt{'62'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="calpagetitle" size="35" value="$calpagetitle"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$ecaltxt{'63'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="caltitle" size="45" value="$caltitle"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$ecaltxt{'64'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text size="50" name="sbjlist" value="$sbjlist"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$ecaltxt{'65'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="sbjdefault" size="15" value="$sbjdefault"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$ecaltxt{'66'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="vwpgtitle" size="40" value="$vwpgtitle"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$ecaltxt{'67'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="vwtitle" size="40" value="$vwtitle"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$ecaltxt{'68'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="enpgtitle" size="30" value="$enpgtitle"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$ecaltxt{'69'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="entitle" size="30" value="$entitle"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$ecaltxt{'70'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="gmtminos" size="5" value="$gmtminos"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$ecaltxt{'75'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="newcalmax" size="5" value="$newcalmax"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$ecaltxt{'72'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=text name="newcalgroup" size="30" value="$newcalgroup"></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$ecaltxt{'71'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="newcalopen" value="1" $newcalopenchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$ecaltxt{'80'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="newcalguest" value="1" $newcalguestchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$ecaltxt{'74'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="newcaldate" value="1" $newcaldatechecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$ecaltxt{'76'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="mondayfirst" value="1" $mondayfirstchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$ecaltxt{'79'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="newcalmoon" value="1" $newcalmoonchecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$ecaltxt{'81'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="newcalmoon2" value="1" $newcalmoon2checked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size="2">$ecaltxt{'82'}</font></td>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}"><input type=checkbox name="addbdays" value="1" $addbdayschecked></td>
  </tr><tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}" colspan="2" align="center" valign="middle">
    <BR><input type=submit value="$txt{'10'}">
    </td>
  </tr>
</table>
</td>
</tr>
</table>
</form>
~;
	$yytitle = $ecaltxt{'60'};
	&template;
	exit;
}
# CalSettings2 saves changes to Newcalendar settings in eventcal.txt.  Called by CalSettings.
sub CalSettings2 {
	&is_admin;
	my @onoff = qw/ newcalopen newcaldate newcalmoon newcalmoon2 addbdays mondayfirst /;
	# Set as 0 or 1 if box was checked or not
	my $fi;
	map { $fi = lc $_; ${$_} = $FORM{$fi} eq 'on' ? 1 : 0; } @onoff;
	$newcalopen = $FORM{'newcalopen'} || 0;
	$newcaldate = $FORM{'newcaldate'} || 0;
	$newcalmoon = $FORM{'newcalmoon'} || 0;
	$newcalmoon2 = $FORM{'newcalmoon2'} || 0;
	$newcalguest = $FORM{'newcalguest'} || 0;
	$mondayfirst = $FORM{'mondayfirst'} || 0;
	$addbdays = $FORM{'addbdays'} || 0;		
	$calpagetitle = $FORM{'calpagetitle'} || 'My Calendar Page';
	$caltitle = $FORM{'caltitle'} || 'My Calendar';
	$sbjlist = $FORM{'sbjlist'} || 'Meeting Game Birthday Anniversary Other';
	$sbjdefault = $FORM{'sbjdefault'} || 'Meeting';
	$vwpgtitle = $FORM{'vwpgtitle'} || 'Notices for Selected Date';
	$vwtitle = $FORM{'vwtitle'} || 'Notices for Selected Date';
	$enpgtitle = $FORM{'enpgtitle'} || 'Edit Notices Page';
	$entitle = $FORM{'entitle'} || 'Edit Notices Page';
	$gmtminos = $FORM{'gmtminos'} || 300;
	$newcalmax = $FORM{'newcalmax'} || 5;
	if ($newcalmax < 1) {$newcalmax = 1};
	$newcalgroup = $FORM{'newcalgroup'} || 'Newcalendar Group';
	my $filler = q~										      ~;
	my $setfile = << "EOF";
###############################################################################
# eventcal.txt - Settings for Newcalendar 3.2				      #
###############################################################################

\$calpagetitle = "$calpagetitle";	# Title of the calendar page (window title)
\$caltitle = "$caltitle";		# Title of the calendar (not the window title)
\$sbjlist = "$sbjlist";			# Selection for subject (type) menu, modify to suit event types desired
\$sbjdefault = "$sbjdefault";		# Default subject list selection
\$vwpgtitle = "$vwpgtitle";		# Viewer page title (window title)
\$vwtitle = "$vwtitle";			# Viewer table title (not the window title)
\$enpgtitle = "$enpgtitle";		# Edit page title (window title)
\$entitle = "$entitle";			# Edit table title (not the window title)
\$gmtminos = $gmtminos;			# Local time offset from GMT in minutes. 300 = 5 hours. I.E Eastern Standard Time
\$newcalmax = $newcalmax;		# Maximum number of events per date (default = 5)
\$newcalgroup = "$newcalgroup"; 	# Name of group to give exclusive calendar access if newcalopen = 0
\$newcalopen = $newcalopen;		# Newcalendar open to all or just admin + group Newcalgroup
\$newcaldate = $newcaldate;		# Newcalendar Date Format: Check for 12/31/2002,<br>uncheck for 31/12/2002
\$newcalmoon = $newcalmoon;		# Newcalendar moon phase on/off switch for main calendar
\$newcalmoon2 = $newcalmoon2;		# Newcalendar moon phase on/off switch for BoardIndex, Who'on, and SSI
\$newcalguest = $newcalguest;		# Newcalendar guest event posting on/off switch
\$mondayfirst = $mondayfirst;		# First day of week: Checked - Sunday, Unchecked - Monday
\$addbdays = $addbdays;			# Add birthdays to calendar: checked on, unchecked off
1;
EOF

	$setfile =~ s~(.+\;)\s+(\#.+$)~$1 . substr( $filler, 0, (70-(length $1)) ) . $2 ~gem;
	$setfile =~ s~(.{64,}\;)\s+(\#.+$)~$1 . "\n   " . $2~gem;
	$setfile =~ s~^\s\s\s+(\#.+$)~substr( $filler, 0, 70 ) . $1~gem;

	fopen(FILE, ">$vardir/eventcal.txt");
	print FILE $setfile;
	fclose(FILE);
	$yySetLocation = qq~$cgi;action=admin~;
	&redirectexit;
}
# WhosCal and WhosCal2 show today's events in the modified Whoson mod
# Split into two subs to allow for addon mods (like WhosBDay), called by Whoson SSI mod
sub WhosCal {
	require "$vardir/eventcal.txt";				       #This is the settings file
	@sbjlist = split(" ",$sbjlist);
	require "$sourcedir/MoonPhase.pl";                           #This is the moon phase calculator
	$dbfile = "$vardir/eventcaldb";				       #This is the database file
	use Time::Local;	#keep?  Try without and see
	use CGI;		#Already called in YaBB but may need more functions
	$webpage_obj = new CGI; #keep or lose?
	$acttype = GetActType();
	@seldate = GetSelDate();
	GetDbData();
	if ($addbdays == 1) {
		WhosBDay();
	}
	WhosCal2();
}
# WhosCal2 shows today's events in the modified Whoson mod, called by WhosCal sub
sub WhosCal2 {
	my($thismonth) = $seldate[0];
	my($thisyear) = $seldate[2];
	$monthname = ($ecaltxt{'01'},$ecaltxt{'02'},$ecaltxt{'03'},$ecaltxt{'04'},$ecaltxt{'05'},$ecaltxt{'06'},$ecaltxt{'07'},$ecaltxt{'08'},$ecaltxt{'09'},$ecaltxt{'10'},$ecaltxt{'11'},$ecaltxt{'12'})[$thismonth];
	my($thisdaysecs) = timegm(0,0,0,1,$thismonth,$thisyear);
	my($thisdayweek) = (gmtime($thisdaysecs))[6];
	my($daysecs) = 24*60*60;
	my(@today) = gmtime(time-$gmtminos*60);
	my($todaysecs) = timegm(0,0,0,$today[3],$today[4],$today[5]);
	my($nextmonth) = $thismonth+1;
	my($nextyear) = $thisyear;
	if($nextmonth > 11) {
		$nextmonth = 0;
		$nextyear = $thisyear+1;
	}
	my($prevmonth) = $thismonth-1;
	my($prevyear) = $thisyear;
	if($prevmonth < 0) {
		$prevmonth = 11;
		$prevyear = $thisyear-1;
	}
	my($thisdaymonth) = 1;
	for($thisdaysecs;$thisdaysecs <= $thisdaysecs+$daysecs*31;$thisdaysecs=$thisdaysecs+$daysecs) {
		last if ((gmtime($thisdaysecs))[4] != $thismonth);
		$data="";
		($thisdaymonth,$thisdayweek) = (gmtime($thisdaysecs))[3,6];
		if (defined($dayinfo{$thisdaysecs})) {
			$data = "";
			foreach $item (@sbjlist) {
				$itemcount=0;
				foreach $info (@{ $dayinfo{$thisdaysecs} }) {
					@daydata = split(/\{/,$info);
					next if($daydata[1] =~ /DELETED/);
# Run UBBC interpreter on the event name.
					$message = $daydata[0]; # put the message back into the proper variable to do ubbc on it
					&wrap;
					if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
					&wrap2;
					$daydata[0] = $message;
# End UBBC
					$daydata[0] =~ s/(^.+)( $)/$1/;
					if($daydata[1] =~ /$item/) {
						if ($itemcount == 0) {
							$data = $data . qq~<li>$daydata[1]:\&nbsp\;<A HREF=\"$scripturl?action=newcalendar&selmonth=$thismonth&selday=$thisdaymonth&selyear=$thisyear&acttype=viewdata\">$daydata[0]</A>~;
							$itemcount++;
						} else {
							$data = $data . qq~,\&nbsp\;<A HREF=\"$scripturl?action=newcalendar&selmonth=$thismonth&selday=$thisdaymonth&selyear=$thisyear&acttype=viewdata\">$daydata[0]</A>~;
							$itemcount++;
						}
					}
				}
			}
# Censor the subject.
			&LoadCensorList;
			foreach (@censored) {
				($tmpa,$tmpb) = @{$_};
				$data =~ s~\Q$tmpa\E~$tmpb~gi;
			}

# End censor subject routine
		}
# Add birthday info from WhosBDay
		if ($addbdays == 1) {
			$data = $data . '<br>' . "$calwhobg";
		}
# Add moon phase info
		if ($newcalmoon2 == 1) {
			( $MoonPhase, $MoonIllum, $MoonAge, $MoonDist, $MoonAng, $SunDist, $SunAng ) = phase();
			my ($newphaselow) = 0.016666667;
			my ($newphasehigh) = 0.983333333;
			my ($phaseincrement) = 0.033333333;

			if ( ($MoonPhase < $newphaselow) || ($MoonPhase > $newphasehigh) ){
				$data = $data . '<br>' . qq~<img src="$imagesdir/moon00.gif" alt="" border="0">~;
			} else {
				$gifnumber = 1;
				for ($phasescan = $newphaselow; $phasescan < $newphasehigh; $phasescan += $phaseincrement) {
					if ( ($MoonPhase > $phasescan) && ( $MoonPhase <= ($phasescan + $phaseincrement)) ){
						if ($gifnumber < 10) {
							$data = $data . '<br>' . qq~<img src="$imagesdir/moon0$gifnumber.gif" alt="" border="0">~;
						} else {
							$data = $data . '<br>' . qq~<img src="$imagesdir/moon$gifnumber.gif" alt="" border="0">~;
						}
					}
					$gifnumber++;
				}
			}
		}
# end moon phase info
		if($todaysecs == $thisdaysecs) {
			print qq~$data~;
		}
	}
}
# WhosBDay adds Today's Birthdays to the modified Whoson mod, called by WhosCal sub
sub WhosBDay {
	&timeformat($date);
	($tocheckm, $tocheckd, $years) = split(/\//, $date);
	($year, $trash) = split(/ /, $years);
	$calwhobd = "";
	$countbd = 0;
	fopen(FILE, "$memberdir/memberlist.txt") || die "cannot open list file";
	@members = <FILE>;
	fclose(FILE);
	foreach $usernames (@members) {
		chomp $usernames;
		if ( -e ("$memberdir/$usernames.dat")) {
			fopen(FILE, "$memberdir/$usernames.dat") || die "cannot open user file";
			@userbd = <FILE>;
			fclose(FILE);
			chomp $userbd[16];
			($matchm, $matchd, $useryear) = split(/\//, $userbd[16]);
			if(($tocheckm == $matchm) && ($tocheckd == $matchd)) {
			$age = $year - $useryear + 2000;
				$calwhobg .=qq~<a href=$cgi&action=viewprofile&username=$usernames>$userbd[1]</a><br>~;
				$countbd++;
			}
		}
	}#end foreach
	chomp $calwhobg;
if ($calwhobg ne "") {$calwhobg = qq~<font size="1" class="catbg">&#187; <b>$ecaltxt{56}</b></font><br>$calwhobg~;}
}

1;
